//https://developers.google.com/maps/documentation/javascript/tutorial

// Variables {{{1
// La version debe coincidir con la del AndroidManifest.xml (solo aparece esta en la version web)
var versao = "4.4";
var veltransito = 2.7; // Estimativa: 2.7 m/s
// Todos en CSV: https://dadosabertos.rio.rj.gov.br/apiTransporte/apresentacao/csv/onibus.cfm
// BRT: https://data.rio/dataset/brt-gps
//var rioonibus = "https://dadosabertos.rio.rj.gov.br/apiTransporte/apresentacao/rest/index.cfm/obterPosicoesDaLinha/";
var rioonibus = "https://jeap.rio.rj.gov.br/dadosAbertosAPI/v2/transporte/veiculos/onibus/"
var accuracyInMts = 40;
var currenTimeInSecs = 0;

var isMobile = true;

var map;
var markerBounds = new google.maps.LatLngBounds();
var rio = new google.maps.LatLng(-22.95357,-43.197960);
var GeoMarker = null;
var pi180 = 0.01745329252; // PI/180;
var cosrio = 0.9208211827; // Math.cos(rio.lat()/360*2Pi)
var infoWindow = new google.maps.InfoWindow();
var labelanchor = new google.maps.Point(13, 57);
var prefit;
var dontfit;
var timefix;
var here;
var sound = true;
var freenotify = true;
var freenotifyid;
var linha = "";
var direction = "";
var idregex = new RegExp("[A-Z][0-9][0-9][0-9]*")
var timer;
var loopCount = 0;
var loopLimit = 20;
var trafficLayer;
var myBuses = {};
var itinPolys = new Array();
var itinPolysEnd = new Array();
var itinLast = -1;
var nextBus = {};
var nextBusAll = 100;
var nextBusAll2 = 100;
var nextBusAll3 = 100;
var nextBusAllMin = 3;
var nextBusAllMax = 30;
var counter = {};
var showplaces = false;
var infodiv;
//}}}1

// Init
function initialize() { //{{{1
  // Options: https://developers.google.com/maps/documentation/javascript/reference#MapOptions
  infodiv = document.getElementById('info');
  infodiv.onclick = function() { restartLinhaLoop(false); }
  isMobile = /AveWebview/.test(navigator.userAgent);

  // Check stop/restart if visible/hidden (not for mobile)
  if (!isMobile) {
    loadMap(window.location.search);
    document.getElementById("bookmark").innerHTML = "Gerar link";
    startstophidden();
  }
  printVersion(versao);
}
function loadMap(str) { //{{{1
  //console.log("###### CARGA ##### " + str);
  // Command line URL parameters
  var herestr = getMatching('aqui|ponto',str);
  var nbamin = getMatching('avmin',str);  // Min to report (command line)
  var nbamax = getMatching('avmax',str);  // Max to report (command line)
  var loolim = getMatching('lolim',str);
  var zoom = getMatching('zoom',str);
  var center = getMatching('center',str);
  var az = getMatching('az',str); // Como azimut: [0,360], norte es 0, va en sentido horario
  if (az && !isNaN(az))
    direction = parseFloat(az*pi180);
  if (nbamin && !isNaN(nbamin))
    nextBusAllMin = nbamin;
  if (nbamax && !isNaN(nbamax))
    nextBusAllMax = nbamax;
  if (loolim && !isNaN(loolim))
    loopLimit = loolim;
  dontfit = (center || zoom);
  var preprefit = getMatching('fit',str).split(",");
  if (!dontfit && preprefit && preprefit.length == 4) {
    prefit = new google.maps.LatLngBounds(
      new google.maps.LatLng(preprefit[0],preprefit[1]),
      new google.maps.LatLng(preprefit[2],preprefit[3]));
  }

  if (map) {
    if (!dontfit && preprefit && preprefit.length == 4) map.fitBounds(prefit);
    if (zoom) map.setZoom(parseInt(zoom,10));
    if (center) map.setCenter(new google.maps.LatLng(center.split(',')[0],center.split(',')[1]));
  } else {
    var panorama = new google.maps.StreetViewPanorama(document.getElementById("map-canvas"), {
          enableCloseButton: true,
          addressControl: true,
          addressControlOptions: { position: google.maps.ControlPosition.TOP_RIGHT },
          // No funcan
          //fullScreenControl: false,
          //fullScreenAddressControlOptions: { visible: false },
          panControl: false,
          zoomControl: false,
          visible: false //set to false so streetview is not triggered on the initial map load
        });

    var mapOptions = {
      disableDefaultUI: true,
      // No funcan
      scaleControl: true,
      scaleControlOptions: {position: google.maps.ControlPosition.BOTTOM_CENTER},
      rotateControl: true,
      draggable: true,
      zoomControl: false,
      mapTypeControl: false,
      streetView: panorama,
      streetViewControl: true,
      streetViewControlOptions: { position: google.maps.ControlPosition.RIGHT_TOP },
      styles: [{featureType: "poi", stylers: [{visibility: "off"}]}], // No propaganda
      center: ((center) ? new google.maps.LatLng(center.split(',')[0],center.split(',')[1]) : rio),
      zoom: ((zoom) ? parseInt(zoom,10) : 14),
      mapTypeId: google.maps.MapTypeId.ROADMAP,
      zIndex: -1
    };
    google.maps.visualRefresh = true;

    map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);

    map.mapTypes.set("OSM", new google.maps.ImageMapType({
      getTileUrl: function(coord, zoom) {
        var tilesPerGlobe = 1 << zoom;
        var x = coord.x % tilesPerGlobe;
        if (x < 0) x = tilesPerGlobe+x;
        //return "https://tile.thunderforest.com/transport/" + zoom + "/" + x + "/" + coord.y + ".png?apikey=c3736c9d39664765b35592bd3c7b4499";
        return "https://luis.impa.br/riobas/OSM/tiles/" + zoom + "/" + x + "/" + coord.y + ".png";
        //return "OSM/tiles/" + zoom + "/" + x + "/" + coord.y + ".png";
      },
      tileSize: new google.maps.Size(256, 256),
      minZoom: 12,
      maxZoom: 16
    }));

    //Duplo click para setear el 'aqui'
    //google.maps.event.addListener(map, 'dblclick', function(event) { setHere(event.latLng.lat()+","+event.latLng.lng()); });
    google.maps.event.addListener(map, 'dblclick', function(event) { setHere(event.latLng); });
  }

  setHere(herestr);
  loadLinha(getMatching('linha',str));
  document.getElementById('linha').style.display = "inline-block";
}
function switchedToMobile() {
  nextBusAllMin = 2;
  //console.log("############ switchedToMobile Try: " + nextBusAllMin);
}
function SoundToggle() {
  sound = ! sound;
  document.getElementById('sound').src = (sound) ? "sound_on.png" : "sound_off.png";
}
function getMatching(name, str){
  var rx = new RegExp('[\&|\?]('+name+')=([^\&\#]+)'),
  val = str.match(rx);
  //return ! val ? '':val[2].replace(/%2C/ig,",").replace(/\s|%20/g,"");
  return ! val ? '':sanitize(val[2]);
}
// How to pass js parameter to URL
function setHere(h) { //{{{1
  var herept;
  var icon;
  if (typeof direction == "number") {
    icon = {
      path: 'M -8,10 0,5 8,10 0,-20 z',
      fillColor: 'green',
      fillOpacity: 0.8,
      scale: 1,
      strokeColor: 'green',
      strokeWeight: 3,
      rotation: Math.round(direction/pi180)
    };
  } else {
    icon = { url: 'here.png', anchor: new google.maps.Point(10,10) };
  }

  if (h) {
    if (typeof h == 'string' || h instanceof String)
      herept = new google.maps.LatLng(h.split(',')[0],h.split(',')[1]);
    else
      herept = h;

    if (here) {
      here.setPosition(herept);
      here.setTitle("Ponto: "+herept.lat().toFixed(6)+","+herept.lng().toFixed(6));
      here.setIcon(icon);
      if (infoWindow.getMap()) infoWindow.close();
    } else {
      here = new google.maps.Marker({
        position: herept,
        title: "Ponto: "+herept.lat().toFixed(6)+","+herept.lng().toFixed(6),
        draggable: true,
        icon: icon,
        crossOnDrag: false,
        //visible:   (!GeoMarker),
        //draggable: (!GeoMarker),
        //clickable: (!GeoMarker),
        map: map, zIndex: 9700
      });
    }

    //updateAllBusStatus();

    if (linha && linha.length > 0 && linha != 0) printbondiinfo("");

    google.maps.event.addListener(here, 'dragend', function() {
      var tit = "Ponto: "+this.position.lat().toFixed(6)+","+this.position.lng().toFixed(6);
      this.setTitle(tit);
      if (infoWindow.getMap()) {
        infoWindow.setContent('<div id="scrollFix">' + tit + '</div>');
        infoWindow.open(map, this);
      }
      var laslinhas = linha.split(",");
      for (var j = 0; j < laslinhas.length; j++) {
        var ele = document.getElementById("nextbus" + laslinhas[j]);
        if (ele) ele.innerHTML = "";
      }
      printbondiinfo("");
    });

    google.maps.event.addListener(here, 'click', function() {
      infoWindow.setContent('<div id="scrollFix">' + this.title + '</div>');
      infoWindow.open(map,this);
    });

    document.getElementById('me').style.visibility = 'visible';

  }
}
//}}}1

// Android BusMap interfaces
function toggleGeoLocation(v) { //{{{1
  //console.log("############ Geo Try ");
  printVersion(v);
  // Mostrar la localizacion: Si comentada, COMENTAR TAMBIEN EL SCRIPT
  //    DEL mapbus.html, y la seccion correspondiente del BusMap.java
  // Porque no funca mas??
  if (!GeoMarker) {
    //console.log("############ Geo Marker "+GeoMarker.getPosition());
    GeoMarker = new GeolocationMarker(map);
    google.maps.event.addListenerOnce(GeoMarker, "position_changed", function() {
      //console.log("############ Geo Listener ");
      if (!here) {
        setHere(GeoMarker.getPosition());
        CenterOnMe();
      }
      //document.getElementById('me').style.visibility = 'visible';
      //google.maps.event.clearListeners(map, 'dblclick');
    });
  } else {
    GeoMarker.setMap(null);
    GeoMarker = null;
  }
}
function CenterOnMe() {
  var loc = here.getPosition();
  if (loc && map) {
    map.panTo(loc);
    map.setZoom(14);
  }
} //}}}1
function sanitize(l) { //{{{1
//  var lll = [];
//  var ll = [];
//  var res = "";
//  var ll = l.replace(/%2C/ig,",").replace(/\s|%20/g,"").split(",");
//  for (var j = 0; j < ll.length; j++) {
//    if (! /[0-9]+/.test(ll[j])) continue;
//    if (ll[j] && lll.indexOf(parseInt(ll[j])) === -1)
//      lll.push(parseInt(ll[j]));
//  }
//  return lll.join(",");
  return l.toUpperCase().replace(/[^A-Z0-9-\.]+/g,",").replace(/,+$|^,+/g,"");
}
function preLoadLinha(l) { //{{{1
  var ll = sanitize(l).split(",");
  var msg = "";

  if (myBuses || Object.keys(myBuses).length > 0)
    for (id in myBuses) myBuses[id].mark.setMap(null);
  myBuses = {};

  for (var j=0; j < ll.length ; j++)
    msg = msg + "<tr id='" + ll[j] + "'><td>" + ll[j] + " </td><td></td><td></td></tr>";
  printinfo(msg);

  loadLinha(l);
}
function loadLinha(l) { //{{{1
  retrieveItinerario();
  linha = sanitize(l);
  //console.log("############ " + getsecs() + " - loadLinha - " + linha+" - "+l);
  if (linha && linha.length > 0 && linha != 0) {
    cleanForm();
    startLinhaLoop(true);
  } else
    changeLinha();
}
function loopLinha(getPrev) { //{{{1
  //console.log("############### LoopLinha");
  retrieveBusDataPHP(getPrev);
  if (!trafficLayer) {
    setTimeout(function() {
      trafficLayer = new google.maps.TrafficLayer({autoRefresh: true, map: map});
      document.getElementById('linhain').focus();
    }, 5000);
  }
}
function reportNextBusAll() {
  if (nextBusAll >= nextBusAllMin && nextBusAll <= nextBusAllMax) {
    if (isMobile) {
        AndroidFunction.notifyy(sound && freenotify, linha, nextBusAllMax, nextBusAll, nextBusAll2, nextBusAll3);
        freenotify = false;
    } else {
      document.title = "Onibus em " + nextBusAll + ", " + nextBusAll2 + " e " + nextBusAll3 + "'";
      if((!document.hasFocus() || sound) && freenotify) {
        freenotify = false;
        // Speech: No funca en Firefox, porque dice que hay "0 voices". Funca en Chrome.
        var msg = new SpeechSynthesisUtterance(document.title.replace("'"," minutos"));
        msg.lang = 'pt-BR';
        window.speechSynthesis.speak(msg);
        // Notification
        if(window.Notification && Notification.permission !== "denied") {
            Notification.requestPermission(function(status) { // status is "granted", if accepted by user
              var n = new Notification("Linhas " + linha, { body: document.title, icon: 'bus_green.png' });
              setTimeout(function() { n.close() }, 3000);
            });
        }
      }
    }
  } else {
    if (isMobile) AndroidFunction.notifyy(false, null, nextBusAllMax, null, null, null);
  }
  freenotify = false;
  freenotifyid = setTimeout(function () { clearTimeout(freenotifyid) ; freenotify = true; }, 20000);
}
//}}}1
function changeLinha() { //{{{1
  itinLast = -1;
  var D = document.getElementById('linhadialog');
  var L = document.getElementById('linha');
  var I = document.getElementById('linhain');
  var S = document.getElementById('linhasen');
  var B = document.getElementById('bookmark');
  var T = document.getElementById('itin');
  //console.log("############ " + getsecs() + " - changeLinha - "+ D.style.display);
  if (D.style.display !== "block") {
    I.value = linha;
    if (direction) S.value = Math.round(direction/pi180);
    document.getElementById('linhaok').onclick = function() { changeLinhaOK(I.value, S.value); }
    D.style.display = "block";
    B.style.display = "none";
    T.style.display = "none";
    L.style.opacity = "1";
    I.focus();
  } else
    cleanForm();
}
function focusLinhaField() {
  // Wrong try to popup virtual keyboard
  document.getElementById('linhain').focus();
}
function cleanForm() {
  document.getElementById('linhadialog').style.display = "none";
  document.getElementById('bookmark').style.display = "inline-block";
  document.getElementById('itin').style.display = "inline-block";
  document.getElementById('linha').style.opacity = "0.6";
}
function changeLinhaOK(res, az) {
  cleanForm();
  if (here) var pos = here.getPosition();
  if (az && !isNaN(az)) {
    direction = parseFloat(az*pi180);
    if (here) {
      here.setMap(null);
      here = null;
      setHere(pos);
    }
  } else {
    direction = "";
    if (here) setHere(pos);
  }

  if (res || az) {
    stopLinhaLoop();
    preLoadLinha(res);
  }
}
//}}}1
function stopLinhaLoop() { //{{{1
  loopCount = 0;
  if (timer) {
    clearInterval(timer);
    timer = null;
    //console.log("############ " + getsecs() + " - stopLinhaLoop: STOPPED " + loopLimit);
  }
}
function startLinhaLoop(getPrev) {
  if (!linha) return;
  if (!timer) {
    var s = (linha.indexOf(',') === -1) ? "" : "s";
    document.title = "Posicao GPS da"+s+" linha"+s+" "+ linha;
    loopLinha(getPrev);
    setTimeout(function () { loopLinha(false); }, 2500);
    timer = setInterval(function() {
       if (loopCount < loopLimit) {
         loopLinha(false);
         loopCount++;
       } else {
         stopLinhaLoop();
         if (isMobile)
            AndroidFunction.exitapp();
       }
    }, 60000);
  }

  // Trying to recover missing markers
  redrawMissingBuses();
}
function restartLinhaLoop(getPrev) {
  stopLinhaLoop();
  startLinhaLoop(getPrev);
}
function redrawMissingBuses() {
  var mrk;
  for (id in myBuses) {
    mrk = myBuses[id].mark;
    if (mrk.getMap() != map || !mrk.getVisible()) {
      var horai = deltime(mrk.title.split("\n")[1]);
      //console.log("########## "+horai+" ########## ")
      if (horai >= 0 && horai <= 1200)
        mrk.setMap(map);
    }
  }
}
function startstophidden() {
  var hidden = "hidden";
  // Standards:
  if (hidden in document)
    document.addEventListener("visibilitychange", onchange);
  else if ((hidden = "mozHidden") in document)
    document.addEventListener("mozvisibilitychange", onchange);
  else if ((hidden = "webkitHidden") in document)
    document.addEventListener("webkitvisibilitychange", onchange);
  else if ((hidden = "msHidden") in document)
    document.addEventListener("msvisibilitychange", onchange);
  // IE 9 and lower:
  else if ('onfocusin' in document)
    document.onfocusin = document.onfocusout = onchange;
  // All others:
  else
    window.onpageshow = window.onpagehide = window.onfocus = window.onblur = onchange;

  function onchange (evt) {
    var v = 'visible', h = 'hidden';
    var evtMap = { focus:v, focusin:v, pageshow:v, blur:h, focusout:h, pagehide:h };
    var state;

    evt = evt || window.event;
    if (evt.type in evtMap) {
      state = evtMap[evt.type];
    } else {
      state = restartLinhaLoop(true);
    }
  }
}
//}}}1

// URL data handling functions
// function retrieveTimeFix() { //{{{1 NOT NEEDED ANYMORE
//   // El getsecs() es hack para evitar el cache
//   var file = "https://luis.impa.br/riobas/timefix.txt?trucho=" + getsecs();
//   var xhReq = new XMLHttpRequest();
//   xhReq.timeout = 30000;
//   xhReq.ontimeout = function() {};
//   xhReq.open("GET", file, true);
//   xhReq.setRequestHeader("Accept", "text/plain");
//   xhReq.onreadystatechange = function() {
//     if (xhReq.status == 200 && xhReq.readyState == 4 && xhReq.responseText) {
//       var timefixnew = parseInt(xhReq.responseText);
//       if (timefixnew != timefix) {
//         console.log("  ## Time adjusted using timefix.txt: " + timefix + " --> " + timefixnew);
//         timefix = timefixnew;
//         restartLinhaLoop();
//       }
//     }
//   }
//   xhReq.send(null);
// }
function cleanItinerario() {
  //console.log("Number PREVIOUS polys: " + itinPolys.length);
  for (var i=0; i < itinPolys.length; i++) {
    if (itinPolys[i] != null) itinPolys[i].setMap(null);
    itinPolys[i] = null;
  }
  for (var i=0; i < itinPolysEnd.length; i++) {
      if (itinPolysEnd[i] != null) itinPolysEnd[i].setMap(null);
      itinPolysEnd[i] = null;
  }
  document.getElementById("itin").innerHTML = "Rota ...";
}
function retrieveItinerario() { //{{{1
  // First remove previous polys and Endpoints
  cleanItinerario();

  var ret;
  const allls = linha.split(",");
  if (! itinLast)
      itinLast = allls[0];
  else {
      const lastind = allls.indexOf(itinLast,0);
      if (lastind == -1 || lastind == allls.length-1) {
        itinLast = "";
        ret = true
      } else
        itinLast = allls[lastind+1];
  }

  if (ret) return;
  document.getElementById("itin").innerHTML = "Rota "+itinLast;

  //fetch("./itinerarios/"+l)
  fetch("https://luis.impa.br/riobas/itinerarios/"+itinLast)
  .then(function(res) { return res.text() } )
  .then(function(text) {
    var color;
    itinPolys = new Array();
    itinPolysEnd = new Array();

    // Draw all polys
    var itin = text.split('\n');
    //console.log("Number of polys for "+l+": "+itin.length);
    for (var i=0; i < itin.length; i++) {
      color = "#000000";
      if (i == 1) color = "#1809e8";
      if (i == 2) color = "#222222";
      if (i == 3) color = "#444444";
      var itinpolidata = JSON.parse(itin[i]);
      //console.log("Number of nodes in poly " + i + " (" + typeof itinpolidata + "): "+itinpolidata.length);

      var itinpolicoords = new Array();
      for (var j=0; j < itinpolidata.length; j++) {
        var point = new google.maps.LatLng(-22 - itinpolidata[j][1],-43 - itinpolidata[j][0]);
        itinpolicoords.push(point);
      }

      itinPolys[i] = new google.maps.Polyline({
        path: itinpolicoords,
        strokeColor: color,
        strokeOpacity: 1.0,
        strokeWeight: 2,
      });

      itinPolys[i].setMap(map);

      itinPolysEnd[i] = new google.maps.Marker({
        position: new google.maps.LatLng(-22 - itinpolidata[0][1],-43 - itinpolidata[0][0]),
        map: map,
        icon: "pontofinal.png",
      });

    }
  })
  .then(function(e) { if (e != undefined) console.log(e); })
}
function retrieveBusDataPHP(getPrev){ //{{{1
  //console.log("############### retrieveBusDataPHP "+linha);
  var spinnerID = setTimeout(function() { document.getElementById('spinner').style.display=""; }, 800);
  // El getsecs() es hack para evitar el cache
  //var file = rioonibus + bus + "?trucho=" + getsecs();
  var file = "https://luis.impa.br/riobas/busdata/index.php?getPrev=" + getPrev + "&linhas=" + linha;
  // No funca mas!
  //if (isMobile && !linha.includes(',')) {
  //   file = rioonibus + linha + "?trucho=" + currenTimeInSecs;
  //}

  //console.log("#########--- " +file);
  var xhReq = new XMLHttpRequest();
  xhReq.timeout = 50000;
  xhReq.ontimeout = function() { console.log("#########--- " + currenTimeInSecs + " - TIMEOUT en retrieveBusDataPHP"); };
  xhReq.open("GET", file, true);
  xhReq.setRequestHeader("Accept", "application/json");
  xhReq.onreadystatechange = function() {
    //console.log("############ " + loopCount + " < " + loopLimit + " - " + xhReq.status + " - " + xhReq.readyState + " - " + xhReq.responseText);
    clearTimeout(spinnerID);
    document.getElementById('spinner').style.display="none";
    if (xhReq.status != 200)
      printbondiinfo("X");
    else {
      if (xhReq.readyState == 4) {
        if (xhReq.responseText)
          processData(xhReq.responseText);
        else
          printbondiinfo("??");
      }
    }
  }
  xhReq.send(null);
}
// Comments {{{2
/* Java
// Cria cliente http.
HttpClient httpclient = new DefaultHttpClient(httpParameters);

// Cria o GET e define a URL.
HttpGet httpget = new HttpGet("https://dadosabertos.rio.rj.gov.br/apiTransporte/apresentacao/rest/index.cfm/obterPosic
    +oesDaLinha/" + linha);

// Define o tipo de dados para a correta execucao do http GET.
httpget.setHeader("Content-Type", "application/json");
httpget.setHeader("Accept", "application/json");

// Envia o pedido de consumo da URL atraves de um GET.
HttpResponse httpResponse = httpclient.execute(httpget);

// Recebe a resposta como "inputStream".
inputStream = httpResponse.getEntity().getContent();

// Converte a inputString obtida no consumo, para String
private static String convertInputStreamToString(InputStream inputStream) throws IOException {
  BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream,"ISO-8859-1"));

  int c;
  StringBuilder response= new StringBuilder();

  // Le do buffer pegando caracter a caracter. Como particularmente este fluxo consumido
  // nao possui fim de linha com newline (\n), o metodo readLine() nao funciona.
  while ((c = bufferedReader.read()) != -1) {
    response.append((char)c);
  }
  String result = response.toString();
  inputStream.close();
  return result;
}
*/ //}}}2
//}}}1
function processData(csv) //{{{1
{
  counter = {};
  var pt;
  var id;
  var arr = (JSON.parse(csv)).data;
  if (arr[0] == "BLOCKED") {
    alert("**** SERVIÇO BLOQUEADO ****\n**** POR  USO  INDEVIDO ****\n\nEste serviço é gratuito,\ne feito exclusivamente\npara usuários finais.");
    stopLinhaLoop();
    window.location.href = "https://luis.impa.br";
    return;
  }
  var bondi
  var tit;
  var allbondispos = [];
  var busmark;
  var hora;
  var horai;
  var numberOfBuses = Object.keys(myBuses).length;
  var lab;
  var linhas = linha.split(',');

  var h=0,o=1,l=2,la=3,lo=4,v=5;

  currenTimeInSecs = parseInt(Date.now()/1000);

  // Loop para cada omnibus...
  for (var i=0; i < arr.length; i++) {
    bondi = arr[i];

    if (!linhas.includes(bondi[l].toString())) continue;
    id = bondi[o];
    // Fora do municipio
    if (bondi[la] < -23.1 || bondi[la] > -22.5 || bondi[lo] < -43.8 || bondi[lo] > -42.9) {
      removeBus(id);
      continue;
    }

    hora = bondi[h];
    horai = deltime(hora);
    // Se murio el bondi?? Eliminar si pasaron mas de 20 minutos
    if (horai < 0 || horai > 1200) {
      removeBus(id);
      continue;
    }

    if (bondi[l] in counter)
      counter[bondi[l]]++;
    else {
      counter[bondi[l]] = 1;
      nextBus[bondi[l]] = null;
    }
    pt = new google.maps.LatLng(bondi[la],bondi[lo]);
    tit = bondi[l] + " - " + id + "\n" + hora + "\n"+Math.round(bondi[v]) + "km/h";

    if (id in myBuses) {
      if (dist(myBuses[id].mark.getPosition(), pt) > accuracyInMts) {
        myBuses[id].oldp = myBuses[id].mark.getPosition();
        // mark.position = pt does not update position until redraw (e.g. zoom)
        myBuses[id].mark.setPosition(pt);
      }

      myBuses[id].mark.setTitle(tit);
    } else {
      busmark = new MarkerWithLabel({
        position: pt,
        title: tit,
        draggable: false,
        raiseOnDrag: true,
        visible: true,
        map: map,
        icon: 'bus.png',
        zIndex: 9000,
        labelContent: "",
        labelAnchor: labelanchor,
        //labelStyle: { opacity: 0.75 }, // For label over buss
        labelClass: "markerlabel" // the CSS class for the label
      });

      lab = timehuman(deltime(busmark.title.split("\n")[1]));
      if (lab > 4) {
        busmark.set('zIndex', 8700);
        busmark.setIcon('bus_yellow.png');
      }
      (lab < 2) ? lab = "" : lab = "/"+lab;
      busmark.set('labelContent', timeOfArrival(busmark)+lab);

      google.maps.event.addListener(busmark, 'click', function() {
        //console.log("############ CLICK!" + this.title);
        infoWindow.setContent(transformTitle(this.title));
        infoWindow.open(map,this);
      });

      myBuses[id] = {};
      myBuses[id].mark = busmark;
      myBuses[id].oldp = busmark.position;
    }
    if (!dontfit) allbondispos.push(pt);
  }
  if (infoWindow.getMap()) {
    var idc = idregex.exec(infoWindow.getContent());
    if (idc in myBuses) infoWindow.setContent(transformTitle(myBuses[idc].mark.title));
  }

  if (numberOfBuses == 0 && Object.keys(myBuses).length > 1 && !dontfit)
    fitmap(allbondispos);

  printbondiinfo("")
}
function removeBus(id)
{
  if (id in myBuses) {
    myBuses[id].mark.setMap(null);
    delete myBuses.id;
  }
}
function printbondiinfo(str)
{
  var lins = linha.split(',');
  var col = "";
  var bondiinfo = "";
  var bus;
  var nstr = "";
  var inner = "";
  var cstr;
  var trbus;
  var bstr;

  if (timefix && timefix != 0) col = " style='text-align: center; color: yellow;'";

  updateAllBusStatus();
  for (var n in lins) {
    nstr = "";
    bus = lins[n];
    trbus = document.getElementById(bus);
    bstr = "<td" + col + ">" + bus + " </td>";
    if (counter[bus] && counter[bus] > 0)
      cstr = "<td>" + counter[bus] + "</td>";
    else
      str = "--";

    if (str.length > 0)
      cstr = "<td style='text-align: center; color: red; fontWeight: bold;'>" + str + "</td>";

    str = "";

    if (nextBus[bus] && !isNaN(nextBus[bus]))
      nstr = nextBus[bus];
    inner = bstr + cstr + "<td id='nextbus" + bus + "'>" + nstr + "</td>";
    bondiinfo = bondiinfo + "<tr id='" + bus + "'>" + inner + "</tr>";
  }
  if (bondiinfo) printinfo(bondiinfo);
  reportNextBusAll();
}
// }}}1
function updateAllBusStatus() { //{{{1
  nextBusAll = 100;
  nextBusAll2 = 100;
  nextBusAll3 = 100;
  nextBus = {};
  if (here)
    for (id in myBuses) updateBusStatus(id);
}
function updateBusStatus(id) {
  // <v,w> = (v.lat * w.lat) + cosrio^2 * v.lng * w.lng
  var mark = myBuses[id].mark;
  // Por desigualdad triangular,  d <= dist(myBuses[id].oldp, myBuses[id].mark.position)
  var d = dist(myBuses[id].oldp, here.position) - dist(mark.position, here.position);
  var passed = (prodo(myBuses[id].oldp,here.position,mark.position) > 0);

  mark.set('labelContent', "");

  // Onibus em vermelho: alejandose
  // Onibus verde: aproximando-se
  // Onibus verde + numero encima: aproximando-se e indo na direcao indicada
  // Onibus verde + numero + / + numero: aproximando-se, indo na direcao certa, mas informacao com delay
  if (d < -accuracyInMts || passed) {
    mark.set('zIndex', 8500);
    mark.setIcon('bus_red.png');
  } else {
    // Si F=latitude, T=longitude, f=F'-F, t=T'-T, d=direction:
    // <,> = sin(d)sin(t)cos(F')-cos(d)[sin(f)cos(t)+(1-cos(t))cos(F)sin(F')]
    // Aproximo con: sin(d)cos(F')t-cos(d)f
    var vapadondequiero = true;
    if (direction)
      vapadondequiero = (Math.sin(direction)*(mark.position.lng()-myBuses[id].oldp.lng())*cosrio
          + Math.cos(direction)*(mark.position.lat()-myBuses[id].oldp.lat()) > 0);

    if (d > accuracyInMts) {
      mark.set('zIndex', 9500);
      mark.setIcon('bus_green.png');
    }

    if (mark.getIcon() !== 'bus_red.png') {
      var toa = timeOfArrival(mark);
      var delay = timehuman(deltime(mark.title.split("\n")[1]));
      if (toa && !isNaN(toa) && vapadondequiero) {
        mark.setTitle(mark.title + "\n" + toa);
        var pop = toa;
        if (delay > 1) pop = pop+"/"+delay;
        mark.set('labelContent', pop);
        if (mark.getIcon() === 'bus_green.png') {
          var itoa = parseInt(toa);
          var liii = mark.title.split(' ')[0];
          if (!nextBus[liii] || nextBus[liii] > itoa) nextBus[liii] = itoa;
          if ((itoa < nextBusAll || itoa < nextBusAll2 || itoa < nextBusAll3) && itoa >= nextBusAllMin) {
            var toSort = [itoa,nextBusAll,nextBusAll2,nextBusAll3];
            toSort.sort(function(a,b){return a-b});
            nextBusAll = toSort[0];
            nextBusAll2 = toSort[1];
            nextBusAll3 = toSort[2];
          }
        }
      } else {
        if (delay > 4) {
          mark.set('zIndex', 9000);
          mark.setIcon('bus_yellow.png');
        }
      }
    }
  }
}
function transformTitle(m) { //{{{1
  //console.log(" ############ " + mm[1] + " " + deltime(mm[1]) + " " + timehuman(deltime(mm[1])));
  var mm = m.split("\n");
  var msg = mm[0] + "<br>Faz: " + timehuman(deltime(mm[1])) + "min<br>Vel: " + mm[2];
  if (mm.length == 4) msg = msg + "<br>Chega em " + mm[3] + "m";
  return '<div id="scrollFix">' + msg + '</div>';
}
function timeOfArrival(mark) { //{{{1
  var msg = "";
  if (here) {
    var falta = Math.ceil(dist(mark.position, here.position)/veltransito);
    var delay = deltime(mark.title.split("\n")[1]);
    msg = timehuman(falta-delay);
  }
  return msg;
}
//}}}1

// Time functions
function deltime(t1) { //{{{1
  return currenTimeInSecs - t1;
}
function timehuman(secs) { //{{{1
  var h = Math.floor(secs/3600);
  if (h<0) return "";
  var m = Math.floor(secs/60-h*60);
  //var s = secs - h*3600 - m*60;
  return ((h>0) ? h+":" : "") + ""+m ;
}
//}}}1

// Auxiliary functions
function fitmap(marks) { //{{{1
  if (prefit) {
    map.fitBounds(prefit);
  } else {
    if (!marks) {
      alert("No data?");
      return;
    } else {
      for (var i = 0; i < marks.length; i++) {
        markerBounds.extend(marks[i]);
      }
      fit();
    }
  }
}
function fit() {
  if (markerBounds && ! markerBounds.isEmpty()) {
    map.fitBounds(markerBounds);
  }
}
//}}}1
function printinfo(msg) { //{{{1
  if (msg && msg.length>0) {
    infodiv.style.visibility = 'visible';
    infodiv.innerHTML = msg;
  } else
    infodiv.style.visibility = 'hidden';
}
//}}}1
function dist(p,q) { //{{{1
  //var c = 0.01745329252; // PI/180;
  // Google (randomly wrong results in Android!) Needs geometry library.
  //return google.maps.geometry.spherical.computeDistanceBetween(p,q);
  // Chord
  //return 9019995.5222 * Math.sqrt((1-Math.cos(c*(p.lat()-q.lat())))
  //   + (1-Math.cos(c*(p.lng()-q.lng()))) * Math.cos(c*p.lat()) * Math.cos(c*q.lat()));
  // Taylor for chord
  //return 111318.845 * Math.sqrt(square(p.lat()-q.lat())
  //     + square(p.lng()-q.lng()) * Math.cos(pi180*p.lat()) * Math.cos(pi180*q.lat()));
  // Taylor for chord, approximating all latitudes to those of Rio
  return 111318.845 * Math.sqrt(square(p.lat()-q.lat()) + square((p.lng()-q.lng())*cosrio));
}
function prod(p,q) {
  return p.lat()*q.lat() + cosrio*cosrio*p.lng()*q.lng();
}
function prodo(p,q,o) {
  return (p.lat()-o.lat())*(q.lat()-o.lat()) + cosrio*cosrio*(p.lng()-o.lng())*(q.lng()-o.lng());
}
function square(x) {
  return x*x;
}
//}}}1
function showBookmark() { //{{{1
  var msg = "?linha=" + linha
    + ((direction) ? "&az=" + Math.round(direction/pi180) : "")
    + "&center=" + map.getCenter().lat().toFixed(5) + "," + map.getCenter().lng().toFixed(5)
    + "&zoom=" + map.getZoom();
  if (here)
    msg = msg + "&ponto=" + here.position.lat().toFixed(5) + "," + here.position.lng().toFixed(5);

  if (isMobile) {
    AndroidFunction.installShortcut(linha.toString(), msg);
  } else
    prompt("Pode gerar um favorito desta configuracao com o link abaixo. "
           + "Dar CTRL+C e ENTER para copiar al clipboard."
           , document.URL.split("?")[0] + msg);
}
function printVersion(v) { //{{{1
  if (typeof v !== 'undefined' && v.toString().length > 0)
    document.getElementById("versao").innerHTML = "RioBas  v. " + v + "<br>&copy; 2014-2023 Luis A. Florit";
}
//}}}1

/* Cookies (TODO) {{{1
var allCookies = [];
function setCookie() {
  var cookiename = prompt("Nome desta pagina: ","");
  if (cookiename != "" && cookiename != null)
    document.cookie = cookiename + "=linha@" + escape(linha) + "; expires=Tue Apr 14 23:22:21 GMT 2020"
}
function getCookies() {
  var c;
  allCookies = document.cookie.split(';');
  for(var i=0; i<ca.length; i++) {
    c = allCookies[i].trim();
    ...
  }
}
}}}1 */

document.title = "Posicao GPS dos onibus e BRT do municipio do Rio de Janeiro";
document.getElementById('spinner').style.display="none";
//retrieveTimeFix();   // Ahora es calculado automaticamente
window.addEventListener('load', initialize);
window.onorientationchange = function() { setTimeout(fit, 500); };

// vim:shiftwidth=2:tabstop=2
